---
title: <label>
slug: Web/HTML/Element/label
tags:
  - Element
  - Forms
  - HTML
  - HTML forms
  - Reference
  - Web
---
<div>{{HTMLRef}}</div>

<p>The <strong>HTML <code>&lt;label&gt;</code> element</strong> represents a caption for an item in a user interface.</p>

<div>{{EmbedInteractiveExample("pages/tabbed/label.html", "tabbed-shorter")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples </a> and send us a pull request.</div>

<p>Associating a <code>&lt;label&gt;</code> with an {{htmlelement("input")}} element offers some major advantages:</p>

<ul>
 <li>The label text is not only visually associated with its corresponding text input; it is programmatically associated with it too. This means that, for example, a screen reader will read out the label when the user is focused on the form input, making it easier for an assistive technology user to understand what data should be entered.</li>
 <li>You can click the associated label to focus/activate the input, as well as the input itself. This increased hit area provides an advantage to anyone trying to activate the input, including those using a touch-screen device.</li>
</ul>

<p>To associate the <code>&lt;label&gt;</code> with an <code>&lt;input&gt;</code> element, you need to give the <code>&lt;input&gt;</code> an <code>id</code> attribute. The <code>&lt;label&gt;</code> then needs a <code>for</code> an attribute whose value is the same as the input's <code>id</code>.</p>

<p>Alternatively, you can nest the <code>&lt;input&gt;</code> directly inside the <code>&lt;label&gt;</code>, in which case the <code>for</code> and <code>id</code> attributes are not needed because the association is implicit:</p>

<pre class="brush: html notranslate">&lt;label&gt;Do you like peas?
  &lt;input type="checkbox" name="peas"&gt;
&lt;/label&gt;
</pre>

<p id="Usage_notes">Other usage notes:</p>

<ul>
 <li>The form control that the label is labeling is called the <em>labeled control</em> of the label element. One input can be associated with multiple labels.</li>
 <li>When a <code>&lt;label&gt;</code> is clicked or tapped and it is associated with a form control, the resulting <code>click</code> event is also raised for the associated control.</li>
</ul>

<h2 id="Attributes">Attributes</h2>

<p>This element includes the <a href="/en-US/docs/Web/HTML/Global_attributes">global attributes</a>.</p>

<dl>
 <dt>{{htmlattrdef("for")}}</dt>
 <dd>The {{htmlattrxref("id")}} of a <a href="/en-US/docs/Web/Guide/HTML/Content_categories#Form_labelable">labelable</a> form-related element in the same document as the <code>&lt;label&gt;</code> element. The first element in the document with an <code>id</code> matching the value of the <code>for</code> attribute is the <em>labeled control</em> for this label element if it is a <a href="https://html.spec.whatwg.org/multipage/forms.html#category-label">labelable element</a>. If it is not labelable then the <code>for</code> attribute has no effect. If there are other elements that also match the <code>id</code> value, later in the document, they are not considered.
 <div class="note"><strong>Note</strong>: A <code>&lt;label&gt;</code> element can have both a <code>for</code> attribute and a contained control element, as long as the <code>for</code> attribute points to the contained control element.</div>
 </dd>
</dl>

<h2 id="Styling_with_CSS">Styling with CSS</h2>

<p>There are no special styling considerations for <code>&lt;label&gt;</code> elements — structurally they are simple inline elements, and so can be styled in much the same way as a {{htmlelement("span")}} or {{htmlelement("a")}} element. You can apply styling to them in any way you want, as long as you don't cause the text to become difficult to read.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Simple_label_example">Simple label example</h3>

<pre class="brush: html notranslate">&lt;label&gt;Click me &lt;input type="text"&gt;&lt;/label&gt;</pre>

<p>{{EmbedLiveSample('Simple_label_example', '200', '50', '')}}</p>

<h3 id="Using_the_for_attribute">Using the "for" attribute</h3>

<pre class="brush: html notranslate">&lt;label for="username"&gt;Click me&lt;/label&gt;
&lt;input type="text" id="username"&gt;</pre>

<p>{{EmbedLiveSample('Using_the_for_attribute', '200', '50', '')}}</p>

<h2 id="Accessibility_concerns">Accessibility concerns</h2>

<h3 id="Interactive_content">Interactive content</h3>

<p>Don't place interactive elements such as {{HTMLElement("a", "anchors")}} or {{HTMLElement("button", "buttons")}} inside a <code>label</code>. Doing so makes it difficult for people to activate the form input associated with the <code>label</code>.</p>

<h4 id="Dont">Don't</h4>

<pre class="brush: html example-bad notranslate">&lt;label for="tac"&gt;
  &lt;input id="tac" type="checkbox" name="terms-and-conditions"&gt;
  I agree to the &lt;a href="terms-and-conditions.html"&gt;Terms and Conditions&lt;/a&gt;
&lt;/label&gt;
</pre>

<h4 id="Do">Do</h4>

<pre class="brush: html example-good notranslate">&lt;label for="tac"&gt;
  &lt;input id="tac" type="checkbox" name="terms-and-conditions"&gt;
  I agree to the Terms and Conditions
&lt;/label&gt;
&lt;p&gt;
  &lt;a href="terms-and-conditions.html"&gt;Read our Terms and Conditions&lt;/a&gt;
&lt;/p&gt;
</pre>

<h3 id="Headings">Headings</h3>

<p>Placing <a href="/en-US/docs/Web/HTML/Element/Heading_Elements">heading elements</a> within a <code>&lt;label&gt;</code> interferes with many kinds of assistive technology, because headings are commonly used as <a href="/en-US/docs/Web/HTML/Element/Heading_Elements#Navigation">a navigation aid</a>. If the label's text needs to be adjusted visually, use CSS classes applied to the <code>&lt;label&gt;</code> element instead.</p>

<p>If a <a href="/en-US/docs/Web/HTML/Element/form">form</a>, or a section of a form needs a title, use the {{HTMLElement("legend")}} element placed within a {{HTMLElement("fieldset")}}.</p>

<h4 id="Dont_2">Don't</h4>

<pre class="brush: html example-bad notranslate">&lt;label for="your-name"&gt;
  &lt;h3&gt;Your name&lt;/h3&gt;
  &lt;input id="your-name" name="your-name" type="text"&gt;
&lt;/label&gt;
</pre>

<h4 id="Do_2">Do</h4>

<pre class="brush: html example-good notranslate">&lt;label class="large-label" for="your-name"&gt;
  Your name
  &lt;input id="your-name" name="your-name" type="text"&gt;
&lt;/label&gt; </pre>

<h3 id="Buttons">Buttons</h3>

<p>An {{HTMLElement("input")}} element with a <code>type="button"</code> declaration and a valid <code>value</code> attribute does not need a label associated with it. Doing so may actually interfere with how assistive technology parses the button input. The same applies for the {{HTMLElement("button")}} element.</p>

<h2 id="Technical_summary">Technical summary</h2>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row"><a href="/en-US/docs/Web/Guide/HTML/Content_categories">Content categories</a></th>
   <td><a href="/en-US/docs/Web/Guide/HTML/Content_categories#Flow_content">Flow content</a>, <a href="/en-US/docs/Web/Guide/HTML/Content_categories#Phrasing_content">phrasing content</a>, <a href="/en-US/docs/Web/Guide/HTML/Content_categories#Interactive_content">interactive content</a>, <a href="/en-US/docs/Web/Guide/HTML/Content_categories#Form-associated_content">form-associated element</a>, palpable content.</td>
  </tr>
  <tr>
   <th scope="row">Permitted content</th>
   <td><a href="/en-US/docs/Web/Guide/HTML/Content_categories#Phrasing_content">Phrasing content</a>, but no descendant <code>label</code> elements. No <a href="/en-US/docs/Web/Guide/HTML/Content_categories#Form_labelable">labelable</a> elements other than the labeled control are allowed.</td>
  </tr>
  <tr>
   <th scope="row">Tag omission</th>
   <td>{{no_tag_omission}}</td>
  </tr>
  <tr>
   <th scope="row">Permitted parents</th>
   <td>Any element that accepts <a href="/en-US/docs/Web/Guide/HTML/Content_categories#Phrasing_content">phrasing content</a>.</td>
  </tr>
  <tr>
   <th scope="row">Implicit ARIA role</th>
   <td><a href="https://www.w3.org/TR/html-aria/#dfn-no-corresponding-role">No corresponding role</a></td>
  </tr>
  <tr>
   <th scope="row">Permitted ARIA roles</th>
   <td>No <code>role</code> permitted</td>
  </tr>
  <tr>
   <th scope="row">DOM interface</th>
   <td>{{domxref("HTMLLabelElement")}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', 'forms.html#the-label-element', '&lt;label&gt;')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5 W3C', 'sec-forms.html#the-label-element', '&lt;label&gt;')}}</td>
   <td>{{Spec2('HTML5 W3C')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName('HTML4.01', 'interact/forms.html#h-17.9.1', '&lt;label&gt;')}}</td>
   <td>{{Spec2('HTML4.01')}}</td>
   <td></td>
  </tr>
  <tr>
   <td><a class="external external-icon" href="https://www.w3.org/TR/REC-html40-971218/interact/forms.html#h-17.9.1" hreflang="en" lang="en" rel="noopener">HTML 4.0 Specification<br>
    <small lang="en-US">The definition of '&lt;label&gt;' in that specification.</small></a></td>
   <td>{{Spec2('HTML4.01')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("html.elements.label")}}</p>
